#include <stdio.h>
#include <stdlib.h>

struct bin_tree {
    int data;
    struct bin_tree *right, *left;
};

typedef struct bin_tree node;

void insert(node **tree, int val) {
    node *temp = NULL;
    if(!(*tree)){
	temp = (node *)malloc(sizeof(node));
	if (!temp){
	    fprintf(stderr, "Could not allocate memory!");
	    exit(1);
	}

	temp->left = temp->right = NULL;
	temp->data = val;
	*tree = temp;
	return;
    }

    if(val < (*tree)->data){
	insert(&(*tree)->left, val);
    }
    else if(val > (*tree)->data){
	insert(&(*tree)->right, val);
    }

}

void print_preorder(node * tree){
    if (tree){
	printf("%d\n",tree->data);
	print_preorder(tree->left);
	print_preorder(tree->right);
    }
}

void print_inorder(node * tree){
    if (tree){
	print_inorder(tree->left);
	printf("%d\n",tree->data);
	print_inorder(tree->right);
    }
}

void print_postorder(node * tree){
    if (tree){
	print_postorder(tree->left);
	print_postorder(tree->right);
	printf("%d\n",tree->data);
    }
}

void deltree(node * tree){
    if (tree){
	deltree(tree->left);
	deltree(tree->right);
	free(tree);
    }
}

int main() {
    node *root;

    root = NULL;

    insert(&root, 9);
    insert(&root, 4);
    insert(&root, 15);
    insert(&root, 6);
    insert(&root, 12);
    insert(&root, 17);
    insert(&root, 2);

    /* Printing nodes of tree */
    printf("Pre Order Display\n");
    print_preorder(root);

    printf("In Order Display\n");
    print_inorder(root);

    printf("Post Order Display\n");
    print_postorder(root);

    deltree(root);

    return 0;
}
